=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class CustomsDeclaration
    # required if eel_pfc is 'AES_ITN'
    attr_accessor :aes_itn

    attr_accessor :b13a_filing_option

    # must be provided if and only if b13a_filing_option is provided
    attr_accessor :b13a_number

    attr_accessor :certificate

    attr_accessor :certify

    attr_accessor :certify_signer

    attr_accessor :commercial_invoice

    # required if contents_type is 'OTHER'
    attr_accessor :contents_explanation

    attr_accessor :contents_type

    attr_accessor :disclaimer

    attr_accessor :eel_pfc

    attr_accessor :exporter_reference

    attr_accessor :importer_reference

    attr_accessor :incoterm

    attr_accessor :invoice

    attr_accessor :items

    attr_accessor :license

    attr_accessor :metadata

    attr_accessor :non_delivery_option

    attr_accessor :notes

    attr_accessor :object_created

    attr_accessor :object_id

    attr_accessor :object_owner

    attr_accessor :object_state

    attr_accessor :object_updated

    attr_accessor :test

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'aes_itn' => :'aes_itn',
        :'b13a_filing_option' => :'b13a_filing_option',
        :'b13a_number' => :'b13a_number',
        :'certificate' => :'certificate',
        :'certify' => :'certify',
        :'certify_signer' => :'certify_signer',
        :'commercial_invoice' => :'commercial_invoice',
        :'contents_explanation' => :'contents_explanation',
        :'contents_type' => :'contents_type',
        :'disclaimer' => :'disclaimer',
        :'eel_pfc' => :'eel_pfc',
        :'exporter_reference' => :'exporter_reference',
        :'importer_reference' => :'importer_reference',
        :'incoterm' => :'incoterm',
        :'invoice' => :'invoice',
        :'items' => :'items',
        :'license' => :'license',
        :'metadata' => :'metadata',
        :'non_delivery_option' => :'non_delivery_option',
        :'notes' => :'notes',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'object_state' => :'object_state',
        :'object_updated' => :'object_updated',
        :'test' => :'test'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'aes_itn' => :'Object',
        :'b13a_filing_option' => :'Object',
        :'b13a_number' => :'Object',
        :'certificate' => :'Object',
        :'certify' => :'Object',
        :'certify_signer' => :'Object',
        :'commercial_invoice' => :'Object',
        :'contents_explanation' => :'Object',
        :'contents_type' => :'Object',
        :'disclaimer' => :'Object',
        :'eel_pfc' => :'Object',
        :'exporter_reference' => :'Object',
        :'importer_reference' => :'Object',
        :'incoterm' => :'Object',
        :'invoice' => :'Object',
        :'items' => :'Object',
        :'license' => :'Object',
        :'metadata' => :'Object',
        :'non_delivery_option' => :'Object',
        :'notes' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'object_state' => :'Object',
        :'object_updated' => :'Object',
        :'test' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::CustomsDeclaration` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::CustomsDeclaration`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'aes_itn')
        self.aes_itn = attributes[:'aes_itn']
      end

      if attributes.key?(:'b13a_filing_option')
        self.b13a_filing_option = attributes[:'b13a_filing_option']
      end

      if attributes.key?(:'b13a_number')
        self.b13a_number = attributes[:'b13a_number']
      end

      if attributes.key?(:'certificate')
        self.certificate = attributes[:'certificate']
      end

      if attributes.key?(:'certify')
        self.certify = attributes[:'certify']
      end

      if attributes.key?(:'certify_signer')
        self.certify_signer = attributes[:'certify_signer']
      end

      if attributes.key?(:'commercial_invoice')
        self.commercial_invoice = attributes[:'commercial_invoice']
      end

      if attributes.key?(:'contents_explanation')
        self.contents_explanation = attributes[:'contents_explanation']
      end

      if attributes.key?(:'contents_type')
        self.contents_type = attributes[:'contents_type']
      end

      if attributes.key?(:'disclaimer')
        self.disclaimer = attributes[:'disclaimer']
      end

      if attributes.key?(:'eel_pfc')
        self.eel_pfc = attributes[:'eel_pfc']
      end

      if attributes.key?(:'exporter_reference')
        self.exporter_reference = attributes[:'exporter_reference']
      end

      if attributes.key?(:'importer_reference')
        self.importer_reference = attributes[:'importer_reference']
      end

      if attributes.key?(:'incoterm')
        self.incoterm = attributes[:'incoterm']
      end

      if attributes.key?(:'invoice')
        self.invoice = attributes[:'invoice']
      end

      if attributes.key?(:'items')
        if (value = attributes[:'items']).is_a?(Array)
          self.items = value
        end
      end

      if attributes.key?(:'license')
        self.license = attributes[:'license']
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'non_delivery_option')
        self.non_delivery_option = attributes[:'non_delivery_option']
      end

      if attributes.key?(:'notes')
        self.notes = attributes[:'notes']
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'object_state')
        self.object_state = attributes[:'object_state']
      end

      if attributes.key?(:'object_updated')
        self.object_updated = attributes[:'object_updated']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @certify.nil?
        invalid_properties.push('invalid value for "certify", certify cannot be nil.')
      end

      if @certify_signer.nil?
        invalid_properties.push('invalid value for "certify_signer", certify_signer cannot be nil.')
      end

      if @contents_type.nil?
        invalid_properties.push('invalid value for "contents_type", contents_type cannot be nil.')
      end

      if @items.nil?
        invalid_properties.push('invalid value for "items", items cannot be nil.')
      end

      if @non_delivery_option.nil?
        invalid_properties.push('invalid value for "non_delivery_option", non_delivery_option cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @certify.nil?
      return false if @certify_signer.nil?
      return false if @contents_type.nil?
      return false if @items.nil?
      return false if @non_delivery_option.nil?
      object_state_validator = EnumAttributeValidator.new('Object', ['INVALID', 'VALID'])
      return false unless object_state_validator.valid?(@object_state)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] object_state Object to be assigned
    def object_state=(object_state)
      validator = EnumAttributeValidator.new('Object', ['INVALID', 'VALID'])
      unless validator.valid?(object_state)
        fail ArgumentError, "invalid value for \"object_state\", must be one of #{validator.allowable_values}."
      end
      @object_state = object_state
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          aes_itn == o.aes_itn &&
          b13a_filing_option == o.b13a_filing_option &&
          b13a_number == o.b13a_number &&
          certificate == o.certificate &&
          certify == o.certify &&
          certify_signer == o.certify_signer &&
          commercial_invoice == o.commercial_invoice &&
          contents_explanation == o.contents_explanation &&
          contents_type == o.contents_type &&
          disclaimer == o.disclaimer &&
          eel_pfc == o.eel_pfc &&
          exporter_reference == o.exporter_reference &&
          importer_reference == o.importer_reference &&
          incoterm == o.incoterm &&
          invoice == o.invoice &&
          items == o.items &&
          license == o.license &&
          metadata == o.metadata &&
          non_delivery_option == o.non_delivery_option &&
          notes == o.notes &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          object_state == o.object_state &&
          object_updated == o.object_updated &&
          test == o.test
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [aes_itn, b13a_filing_option, b13a_number, certificate, certify, certify_signer, commercial_invoice, contents_explanation, contents_type, disclaimer, eel_pfc, exporter_reference, importer_reference, incoterm, invoice, items, license, metadata, non_delivery_option, notes, object_created, object_id, object_owner, object_state, object_updated, test].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
